pub mod requests;
pub mod responses;

use serde::{Deserialize, Serialize};
use uuid::Uuid;

#[derive(Debug, Deserialize, Serialize)]
pub enum ItemState {
    Created,
    Done,
    Archived,
    Deleted,
}

#[derive(Debug, Serialize, Deserialize)]
pub struct ItemDto {
    pub id: Uuid,
    pub title: String,
    pub description: Option<String>,
    pub state: ItemState,
}
